--- usr/share/arduino/hardware/arduino/boards.txt	2011-12-28 01:38:31.000000000 +0800
+++ usr/share/arduino/hardware/arduino/boards.txt	2003-01-01 12:22:54.000000000 +0800
@@ -1,5 +1,62 @@
 ##############################################################
 
+mini8.name=mini8-16Mhz
+
+mini8.upload.protocol=arduino
+mini8.upload.maximum_size=7680
+mini8.upload.speed=19200
+
+mini8.bootloader.low_fuses=0xbf
+mini8.bootloader.high_fuses=0xcc
+mini8.bootloader.path=optiboot
+mini8.bootloader.file=optiboot_atmega8l16m.hex
+mini8.bootloader.unlock_bits=0x3F
+mini8.bootloader.lock_bits=0x0F
+
+mini8.build.mcu=atmega8
+mini8.build.f_cpu=16000000L
+mini8.build.core=arduino
+mini8.build.variant=standard
+
+
+##########################################
+
+p12.name=p12
+p12.upload.protocol=arduino
+p12.upload.maximum_size=7680
+p12.upload.speed=19200
+
+p12.bootloader.low_fuses=0xf4
+p12.bootloader.high_fuses=0xca
+p12.bootloader.path=optiboot
+p12.bootloader.file=optiboot_atmega8l12m.hex
+p12.bootloader.unlock_bits=0x3F
+p12.bootloader.lock_bits=0x0F
+
+p12.build.mcu=atmega8
+p12.build.f_cpu=12000000L
+p12.build.core=arduino
+p12.build.variant=standard
+##########################################
+
+p8.name=p8
+p8.upload.protocol=arduino
+p8.upload.maximum_size=7680
+p8.upload.speed=19200
+
+p8.bootloader.low_fuses=0xf4
+p8.bootloader.high_fuses=0xca
+p8.bootloader.path=optiboot
+p8.bootloader.file=optiboot_atmega8l.hex
+p8.bootloader.unlock_bits=0x3F
+p8.bootloader.lock_bits=0x0F
+
+p8.build.mcu=atmega8
+p8.build.f_cpu=8000000L
+p8.build.core=arduino
+p8.build.variant=standard
+##############################################################
+
 uno.name=Arduino Uno
 uno.upload.protocol=arduino
 uno.upload.maximum_size=32256
@@ -459,7 +516,7 @@
 
 atmega8.upload.protocol=arduino
 atmega8.upload.maximum_size=7168
-atmega8.upload.speed=19200
+atmega8.upload.speed=115200
 
 atmega8.bootloader.low_fuses=0xdf
 atmega8.bootloader.high_fuses=0xca
@@ -472,3 +529,4 @@
 atmega8.build.f_cpu=16000000L
 atmega8.build.core=arduino
 atmega8.build.variant=standard
+
--- usr/share/arduino/hardware/arduino/bootloaders/optiboot/Makefile	2011-12-28 01:38:31.000000000 +0800
+++ usr/share/arduino/hardware/arduino1/bootloaders/optiboot/Makefile	2011-12-24 19:08:58.000000000 +0800
@@ -31,9 +31,9 @@
 
 
 # enter the parameters for the avrdude isp tool
-ISPTOOL	   = stk500v2
-ISPPORT	   = usb
-ISPSPEED   = -b 115200
+ISPTOOL	   = usbasp
+#ISPPORT	   = usb
+#ISPSPEED   = -b 115200
 
 MCU_TARGET = atmega168
 LDSECTIONS  = -Wl,--section-start=.text=0x3e00 -Wl,--section-start=.version=0x3ffe
@@ -296,6 +296,30 @@
 atmega8_isp: LFUSE = BF
 atmega8_isp: isp
 
+atmega8l: TARGET = atmega8
+atmega8l: MCU_TARGET = atmega8
+atmega8l: CFLAGS += '-DLED_START_FLASHES=4' '-DBAUD_RATE=19200'
+atmega8l: AVR_FREQ = 8000000L 
+atmega8l: LDSECTIONS  = -Wl,--section-start=.text=0x1e00 -Wl,--section-start=.version=0x1ffe
+atmega8l: $(PROGRAM)_atmega8l.hex
+atmega8l: $(PROGRAM)_atmega8l.lst
+# SPIEN, CKOPT, Bootsize=512B
+atmega8l: HFUSE = CC
+atmega8l: LFUSE = F4
+atmega8l: isp
+
+atmega8l16m: TARGET = atmega8
+atmega8l16m: MCU_TARGET = atmega8
+atmega8l16m: CFLAGS += '-DLED_START_FLASHES=1' '-DBAUD_RATE=19200'
+atmega8l16m: AVR_FREQ = 16000000L 
+atmega8l16m: LDSECTIONS  = -Wl,--section-start=.text=0x1e00 -Wl,--section-start=.version=0x1ffe
+atmega8l16m: $(PROGRAM)_atmega8l16m.hex
+atmega8l16m: $(PROGRAM)_atmega8l16m.lst
+# SPIEN, CKOPT, Bootsize=512B
+atmega8l16m: HFUSE = CC
+atmega8l16m: LFUSE = BF
+atmega8l16m: isp
+
 # ATmega88
 #
 atmega88: TARGET = atmega88
--- usr/share/arduino/hardware/arduino/bootloaders/optiboot/optiboot_atmega8l16m.hex	1970-01-01 08:00:00.000000000 +0800
+++ usr/share/arduino/hardware/arduino/bootloaders/optiboot/optiboot_atmega8l16m.hex	2011-12-24 19:09:18.000000000 +0800
@@ -0,0 +1,33 @@
+:101E000011248FE594E09EBF8DBF84B714BE81FF7F
+:101E1000E2D085E08EBD82E08BB988E18AB986E8A0
+:101E200080BD87E689B98EE0C2D0BD9A92E020E3FA
+:101E30003CEF54E040E23DBD2CBD58BF08B602FE69
+:101E4000FDCF88B3842788BBA8959150A1F7CC24F7
+:101E5000DD2488248394B5E0AB2EA1E19A2EF3E033
+:101E6000BF2E9ED0813461F49BD0082FA4D00238BD
+:101E700011F0013811F484E001C083E08DD089C0F5
+:101E8000823411F484E103C0853419F485E09BD0D9
+:101E900080C0853579F484D0E82EFF2481D0082FC6
+:101EA00010E0102F00270E291F29000F111F83D0CB
+:101EB00068016FC0863521F484E085D080E0DECFF4
+:101EC000843609F040C06CD06BD0082F69D080E018
+:101ED000C81688E1D80618F4F601B7BEE895C0E048
+:101EE000D1E05ED089930C17E1F7F0E0CF16F8E16E
+:101EF000DF0618F0F601B7BEE8955DD007B600FC26
+:101F0000FDCFA601A0E0B1E02C9130E011968C91BC
+:101F1000119790E0982F8827822B932B1296FA0125
+:101F20000C0187BEE89511244E5F5F4FF1E0A034AD
+:101F3000BF0751F7F601A7BEE89507B600FCFDCF35
+:101F400097BEE89526C08437B1F42AD029D0F82E60
+:101F500027D031D0F601EF2C8F010F5F1F4F8491F6
+:101F60001BD0EA94F801C1F70894C11CD11CFA9463
+:101F7000CF0CD11C0EC0853739F41DD08EE10CD0AA
+:101F800083E90AD087E07ACF813511F488E00FD059
+:101F900012D080E101D065CF5D9BFECF8CB9089552
+:101FA0005F9BFECF5C9901C0A8958CB1089598E124
+:101FB00091BD81BD0895F4DF803219F088E0F7DF2C
+:101FC000FFCF84E1E9CF1F93182FEADF1150E9F723
+:101FD000F2DF1F91089580E0EADFEE27FF270994E2
+:021FFE000404D9
+:0400000300001E00DB
+:00000001FF
--- usr/share/arduino/hardware/arduino/bootloaders/optiboot/optiboot_atmega8l.hex	1970-01-01 08:00:00.000000000 +0800
+++ usr/share/arduino/hardware/arduino/bootloaders/optiboot/optiboot_atmega8l.hex	2011-12-24 18:38:39.000000000 +0800
@@ -0,0 +1,33 @@
+:101E000011248FE594E09EBF8DBF84B714BE81FF7F
+:101E1000E2D085E08EBD82E08BB988E18AB986E8A0
+:101E200080BD83E389B98EE0C2D0BD9A98E028E1F5
+:101E30003EEF54E040E23DBD2CBD58BF08B602FE67
+:101E4000FDCF88B3842788BBA8959150A1F7CC24F7
+:101E5000DD2488248394B5E0AB2EA1E19A2EF3E033
+:101E6000BF2E9ED0813461F49BD0082FA4D00238BD
+:101E700011F0013811F484E001C083E08DD089C0F5
+:101E8000823411F484E103C0853419F485E09BD0D9
+:101E900080C0853579F484D0E82EFF2481D0082FC6
+:101EA00010E0102F00270E291F29000F111F83D0CB
+:101EB00068016FC0863521F484E085D080E0DECFF4
+:101EC000843609F040C06CD06BD0082F69D080E018
+:101ED000C81688E1D80618F4F601B7BEE895C0E048
+:101EE000D1E05ED089930C17E1F7F0E0CF16F8E16E
+:101EF000DF0618F0F601B7BEE8955DD007B600FC26
+:101F0000FDCFA601A0E0B1E02C9130E011968C91BC
+:101F1000119790E0982F8827822B932B1296FA0125
+:101F20000C0187BEE89511244E5F5F4FF1E0A034AD
+:101F3000BF0751F7F601A7BEE89507B600FCFDCF35
+:101F400097BEE89526C08437B1F42AD029D0F82E60
+:101F500027D031D0F601EF2C8F010F5F1F4F8491F6
+:101F60001BD0EA94F801C1F70894C11CD11CFA9463
+:101F7000CF0CD11C0EC0853739F41DD08EE10CD0AA
+:101F800083E90AD087E07ACF813511F488E00FD059
+:101F900012D080E101D065CF5D9BFECF8CB9089552
+:101FA0005F9BFECF5C9901C0A8958CB1089598E124
+:101FB00091BD81BD0895F4DF803219F088E0F7DF2C
+:101FC000FFCF84E1E9CF1F93182FEADF1150E9F723
+:101FD000F2DF1F91089580E0EADFEE27FF270994E2
+:021FFE000404D9
+:0400000300001E00DB
+:00000001FF
